/* Actions (message types) */
mtype = { nop, a10, a4, a50, a47, a2, a26, a3, a51, a44, a13, a12, a52, a15, a30, a18, a9, a31, a1, a17, a57, a32, a48, a55, a25, a29, a24, a7, a41, a39, a33, a61, a22, a21, a11, a63, a8, a16, a40, a35, a28, a42, a6, a65, a64, a36, a60, a14, a27, a34, a62, a46, a59, a5, a38, a58, a19, a20, a37, a23, a54, a45, a56, a49, a53, a43 };

/* Inter-process channels */
chan p10_7 = [0] of {mtype};
chan p7_6 = [0] of {mtype};
chan p9_7 = [0] of {mtype};
chan p8_5 = [0] of {mtype};
chan p10_4 = [0] of {mtype};
chan p10_8 = [0] of {mtype};
chan p11_4 = [0] of {mtype};
chan p8_3 = [0] of {mtype};
chan p9_2 = [0] of {mtype};
chan p9_1 = [0] of {mtype};
chan p1_0 = [0] of {mtype};

/* Environement<->process channels */
chan p10 = [0] of {mtype};
chan p5 = [0] of {mtype};
chan p4 = [0] of {mtype};
chan p11 = [0] of {mtype};
chan p9 = [0] of {mtype};
chan p8 = [0] of {mtype};
chan p7 = [0] of {mtype};
chan p6 = [0] of {mtype};
chan p3 = [0] of {mtype};
chan p2 = [0] of {mtype};
chan p1 = [0] of {mtype};
chan p0 = [0] of {mtype};

/* Environment process */
active proctype Environment()
{
  do
  :: p10 ! a10
  :: p10 ! a4
  :: p10 ! a50
  :: p10 ! a47
  :: p10 ! a2
  :: p10 ! a26
  :: p10 ! a3
  :: p10 ! a51
  :: p10 ! a44
  :: p10 ! a13
  :: p10 ! a12
  :: p10 ! a52
  :: p10 ! a15
  :: p10 ! a30
  :: p10 ! a18
  :: p10 ! a9
  :: p10 ! a31
  :: p10 ! a1
  :: p10 ! a17
  :: p10 ! a57
  :: p10 ! a32
  :: p10 ! a48
  :: p10 ! a55
  :: p10 ! a25
  :: p10 ! a29
  :: p10 ! a24
  :: p5 ! a61
  :: p10 ! a22
  :: p5 ! a21
  :: p10 ! a11
  :: p4 ! a35
  :: p10 ! a5
  :: p5 ! a19
  :: p10 ! a23
  :: p10 ! a56
  :: p10 ! a49
  :: p10 ! a43
  :: p11 ! nop
  :: p10 ! nop
  :: p9 ! nop
  :: p8 ! nop
  :: p7 ! nop
  :: p6 ! nop
  :: p5 ! nop
  :: p4 ! nop
  :: p3 ! nop
  :: p2 ! nop
  :: p1 ! nop
  :: p0 ! nop
  od
}

/* Action channel */
chan act = [0] of {mtype};

/* Most recent message event */
mtype lastAction = nop;

/* Action listener */
active proctype Listener()
{
  atomic {
    do
    :: act ? lastAction ->
  step: skip
    od
  }
}

/* Process 0 */
active proctype Proc0()
{
  int state = 5;
  do
  :: state == 5 ->
    atomic {
      if
      :: p0 ? nop ->

        state = 4;
      fi
    }
  :: state == 4 ->
    atomic {
      if
      :: p1_0 ? a53 ->
        act ! a53;
        state = 2;
      :: p1_0 ? a20 ->
        act ! a20;
        state = 3;
      fi
    }
  :: state == 2 ->
    atomic {
      if
      :: p1_0 ? a53 ->
        act ! a53;
        state = 3;
      :: p1_0 ? a54 ->
        act ! a54;
        state = 1;
      fi
    }
  :: state == 1 ->
    atomic {
      if
      :: p1_0 ? a20 ->
        act ! a20;
        state = 4;
      :: p1_0 ? a54 ->
        act ! a54;
        state = 3;
      fi
    }
  od
}

/* Process 1 */
active proctype Proc1()
{
  int state = 19;
  do
  :: state == 19 ->
    atomic {
      if
      :: p1 ? nop ->

        state = 13;
      fi
    }
  :: state == 13 ->
    atomic {
      if
      :: p9_1 ? a58 ->
        act ! a58;
        state = 16;
      fi
    }
  :: state == 16 ->
    atomic {
      if
      :: p1_0 ! a53 ->

        state = 9;
      fi
    }
  :: state == 9 ->
    atomic {
      if
      :: p1_0 ! a54 ->

        state = 8;
      fi
    }
  :: state == 8 ->
    atomic {
      if
      :: p1_0 ! a20 ->

        state = 7;
      fi
    }
  :: state == 7 ->
    atomic {
      if
      :: p9_1 ? a58 ->
        act ! a58;
        state = 10;
      :: p9_1 ? a59 ->
        act ! a59;
        state = 12;
      fi
    }
  :: state == 10 ->
    atomic {
      if
      :: p1_0 ! a53 ->

        state = 6;
      fi
    }
  :: state == 12 ->
    atomic {
      if
      :: p1_0 ! a53 ->

        state = 18;
      fi
    }
  :: state == 6 ->
    atomic {
      if
      :: p1_0 ! a54 ->

        state = 14;
      fi
    }
  :: state == 18 ->
    atomic {
      if
      :: p1_0 ! a54 ->

        state = 17;
      fi
    }
  :: state == 14 ->
    atomic {
      if
      :: p1_0 ! a20 ->

        state = 11;
      fi
    }
  :: state == 17 ->
    atomic {
      if
      :: p1_0 ! a20 ->

        state = 15;
      fi
    }
  :: state == 11 ->
    atomic {
      if
      :: p9_1 ? a58 ->
        act ! a58;
        state = 10;
      fi
    }
  :: state == 15 ->
    atomic {
      if
      :: p9_1 ? a58 ->
        act ! a58;
        state = 16;
      fi
    }
  od
}

/* Process 2 */
active proctype Proc2()
{
  int state = 25;
  do
  :: state == 25 ->
    atomic {
      if
      :: p2 ? nop ->

        state = 23;
      fi
    }
  :: state == 23 ->
    atomic {
      if
      :: p9_2 ? a34 ->
        act ! a34;
        state = 22;
      :: p9_2 ? a60 ->
        act ! a60;
        state = 21;
      fi
    }
  :: state == 22 ->
    atomic {
      if
      :: p9_2 ? a60 ->
        act ! a60;
        state = 20;
      fi
    }
  :: state == 21 ->
    atomic {
      if
      :: p9_2 ? a60 ->
        act ! a60;
        state = 21;
      fi
    }
  :: state == 20 ->
    atomic {
      if
      :: p9_2 ? a34 ->
        act ! a34;
        state = 24;
      fi
    }
  :: state == 24 ->
    atomic {
      if
      :: p9_2 ? a60 ->
        act ! a60;
        state = 23;
      :: p9_2 ? a34 ->
        act ! a34;
        state = 21;
      fi
    }
  od
}

/* Process 3 */
active proctype Proc3()
{
  int state = 30;
  do
  :: state == 30 ->
    atomic {
      if
      :: p3 ? nop ->

        state = 29;
      fi
    }
  :: state == 29 ->
    atomic {
      if
      :: p8_3 ? a42 ->
        act ! a42;
        state = 27;
      fi
    }
  :: state == 27 ->
    atomic {
      if
      :: p8_3 ? a64 ->
        act ! a64;
        state = 28;
      :: p8_3 ? a62 ->
        act ! a62;
        state = 26;
      fi
    }
  :: state == 28 ->
    atomic {
      if
      :: p8_3 ? a62 ->
        act ! a62;
        state = 28;
      fi
    }
  :: state == 26 ->
    atomic {
      if
      :: p8_3 ? a64 ->
        act ! a64;
        state = 29;
      :: p8_3 ? a42 ->
        act ! a42;
        state = 28;
      fi
    }
  od
}

/* Process 4 */
active proctype Proc4()
{
  int state = 42;
  do
  :: state == 42 ->
    atomic {
      if
      :: p4 ? nop ->

        state = 34;
      fi
    }
  :: state == 34 ->
    atomic {
      if
      :: p10_4 ? a8 ->
        act ! a8;
        state = 38;
      :: p10_4 ? a46 ->
        act ! a46;
        state = 32;
      fi
    }
  :: state == 38 ->
    atomic {
      if
      :: p11_4 ? a37 ->
        act ! a37;
        state = 41;
      fi
    }
  :: state == 32 ->
    atomic {
      if
      :: p11_4 ? a37 ->
        act ! a37;
        state = 33;
      fi
    }
  :: state == 41 ->
    atomic {
      if
      :: p11_4 ? a37 ->
        act ! a37;
        state = 36;
      :: p4 ? a35 ->
        act ! a35;
        state = 40;
      fi
    }
  :: state == 33 ->
    atomic {
      if
      :: p4 ? a35 ->
        act ! a35;
        state = 37;
      fi
    }
  :: state == 36 ->
    atomic {
      if
      :: p4 ? a35 ->
        act ! a35;
        state = 36;
      :: p11_4 ? a40 ->
        act ! a40;
        state = 36;
      :: p10_4 ? a8 ->
        act ! a8;
        state = 36;
      :: p10_4 ? a45 ->
        act ! a45;
        state = 36;
      :: p11_4 ? a37 ->
        act ! a37;
        state = 36;
      fi
    }
  :: state == 40 ->
    atomic {
      if
      :: p11_4 ? a36 ->
        act ! a36;
        state = 39;
      fi
    }
  :: state == 37 ->
    atomic {
      if
      :: p11_4 ? a37 ->
        act ! a37;
        state = 36;
      :: p11_4 ? a36 ->
        act ! a36;
        state = 35;
      fi
    }
  :: state == 39 ->
    atomic {
      if
      :: p11_4 ? a40 ->
        act ! a40;
        state = 34;
      fi
    }
  :: state == 35 ->
    atomic {
      if
      :: p11_4 ? a40 ->
        act ! a40;
        state = 31;
      fi
    }
  :: state == 31 ->
    atomic {
      if
      :: p10_4 ? a45 ->
        act ! a45;
        state = 38;
      fi
    }
  od
}

/* Process 5 */
active proctype Proc5()
{
  int state = 55;
  do
  :: state == 55 ->
    atomic {
      if
      :: p5 ? nop ->

        state = 53;
      fi
    }
  :: state == 53 ->
    atomic {
      if
      :: p8_5 ? a63 ->
        act ! a63;
        state = 54;
      fi
    }
  :: state == 54 ->
    atomic {
      if
      :: p5 ? a19 ->
        act ! a19;
        state = 46;
      fi
    }
  :: state == 46 ->
    atomic {
      if
      :: p5 ? a61 ->
        act ! a61;
        state = 45;
      fi
    }
  :: state == 45 ->
    atomic {
      if
      :: p5 ? a21 ->
        act ! a21;
        state = 52;
      fi
    }
  :: state == 52 ->
    atomic {
      if
      :: p8_5 ? a63 ->
        act ! a63;
        state = 51;
      :: p8_5 ? a65 ->
        act ! a65;
        state = 50;
      fi
    }
  :: state == 51 ->
    atomic {
      if
      :: p5 ? a19 ->
        act ! a19;
        state = 49;
      fi
    }
  :: state == 50 ->
    atomic {
      if
      :: p5 ? a19 ->
        act ! a19;
        state = 44;
      fi
    }
  :: state == 49 ->
    atomic {
      if
      :: p5 ? a61 ->
        act ! a61;
        state = 43;
      fi
    }
  :: state == 44 ->
    atomic {
      if
      :: p5 ? a61 ->
        act ! a61;
        state = 48;
      fi
    }
  :: state == 43 ->
    atomic {
      if
      :: p5 ? a21 ->
        act ! a21;
        state = 47;
      fi
    }
  :: state == 48 ->
    atomic {
      if
      :: p5 ? a21 ->
        act ! a21;
        state = 53;
      fi
    }
  :: state == 47 ->
    atomic {
      if
      :: p8_5 ? a65 ->
        act ! a65;
        state = 51;
      fi
    }
  od
}

/* Process 6 */
active proctype Proc6()
{
  int state = 61;
  do
  :: state == 61 ->
    atomic {
      if
      :: p6 ? nop ->

        state = 59;
      fi
    }
  :: state == 59 ->
    atomic {
      if
      :: p7_6 ? a33 ->
        act ! a33;
        state = 58;
      :: p7_6 ? a41 ->
        act ! a41;
        state = 57;
      fi
    }
  :: state == 58 ->
    atomic {
      if
      :: p7_6 ? a33 ->
        act ! a33;
        state = 58;
      :: p7_6 ? a41 ->
        act ! a41;
        state = 58;
      fi
    }
  :: state == 57 ->
    atomic {
      if
      :: p7_6 ? a33 ->
        act ! a33;
        state = 56;
      fi
    }
  :: state == 56 ->
    atomic {
      if
      :: p7_6 ? a41 ->
        act ! a41;
        state = 60;
      fi
    }
  :: state == 60 ->
    atomic {
      if
      :: p7_6 ? a33 ->
        act ! a33;
        state = 56;
      fi
    }
  od
}

/* Process 7 */
active proctype Proc7()
{
  int state = 73;
  do
  :: state == 73 ->
    atomic {
      if
      :: p7 ? nop ->

        state = 63;
      fi
    }
  :: state == 63 ->
    atomic {
      if
      :: p10_7 ? a28 ->
        act ! a28;
        state = 67;
      :: p10_7 ? a6 ->
        act ! a6;
        state = 68;
      fi
    }
  :: state == 67 ->
    atomic {
      if
      :: p7_6 ! a41 ->

        state = 64;
      fi
    }
  :: state == 68 ->
    atomic {
      if
      :: p7_6 ! a41 ->

        state = 70;
      fi
    }
  :: state == 64 ->
    atomic {
      if
      :: p9_7 ? a38 ->
        act ! a38;
        state = 62;
      fi
    }
  :: state == 70 ->
    atomic {
      if
      :: p9_7 ? a38 ->
        act ! a38;
        state = 71;
      fi
    }
  :: state == 62 ->
    atomic {
      if
      :: p9_7 ? a39 ->
        act ! a39;
        state = 72;
      fi
    }
  :: state == 71 ->
    atomic {
      if
      :: p9_7 ? a39 ->
        act ! a39;
        state = 69;
      fi
    }
  :: state == 72 ->
    atomic {
      if
      :: p7_6 ! a33 ->

        state = 63;
      :: p9_7 ? a39 ->
        act ! a39;
        state = 65;
      fi
    }
  :: state == 69 ->
    atomic {
      if
      :: p7_6 ! a33 ->

        state = 66;
      fi
    }
  :: state == 65 ->
    atomic {
      if
      :: p10_7 ? a6 ->
        act ! a6;
        state = 65;
      :: p10_7 ? a7 ->
        act ! a7;
        state = 65;
      :: p9_7 ? a38 ->
        act ! a38;
        state = 65;
      :: p7_6 ! a41 ->

        state = 65;
      :: p10_7 ? a28 ->
        act ! a28;
        state = 65;
      fi
    }
  :: state == 66 ->
    atomic {
      if
      :: p10_7 ? a7 ->
        act ! a7;
        state = 67;
      fi
    }
  od
}

/* Process 8 */
active proctype Proc8()
{
  int state = 94;
  do
  :: state == 94 ->
    atomic {
      if
      :: p8 ? nop ->

        state = 83;
      fi
    }
  :: state == 83 ->
    atomic {
      if
      :: p10_8 ? a14 ->
        act ! a14;
        state = 89;
      :: p10_8 ? a27 ->
        act ! a27;
        state = 81;
      fi
    }
  :: state == 89 ->
    atomic {
      if
      :: p8_3 ! a42 ->

        state = 91;
      fi
    }
  :: state == 81 ->
    atomic {
      if
      :: p8_3 ! a42 ->

        state = 85;
      :: p8_3 ! a64 ->

        state = 79;
      fi
    }
  :: state == 91 ->
    atomic {
      if
      :: p8_5 ! a65 ->

        state = 75;
      :: p8_3 ! a62 ->

        state = 93;
      fi
    }
  :: state == 85 ->
    atomic {
      if
      :: p8_3 ! a62 ->

        state = 82;
      fi
    }
  :: state == 79 ->
    atomic {
      if
      :: p8_3 ! a42 ->

        state = 79;
      :: p8_5 ! a63 ->

        state = 79;
      :: p10_8 ? a16 ->
        act ! a16;
        state = 79;
      :: p8_3 ! a62 ->

        state = 79;
      fi
    }
  :: state == 75 ->
    atomic {
      if
      :: p8_3 ! a42 ->

        state = 75;
      :: p10_8 ? a14 ->
        act ! a14;
        state = 75;
      :: p8_3 ! a62 ->

        state = 75;
      :: p8_5 ! a63 ->

        state = 75;
      :: p10_8 ? a27 ->
        act ! a27;
        state = 75;
      :: p8_5 ! a65 ->

        state = 75;
      fi
    }
  :: state == 93 ->
    atomic {
      if
      :: p8_5 ! a63 ->

        state = 90;
      fi
    }
  :: state == 82 ->
    atomic {
      if
      :: p8_5 ! a63 ->

        state = 92;
      fi
    }
  :: state == 90 ->
    atomic {
      if
      :: p8_3 ! a64 ->

        state = 74;
      fi
    }
  :: state == 92 ->
    atomic {
      if
      :: p8_3 ! a64 ->

        state = 86;
      fi
    }
  :: state == 74 ->
    atomic {
      if
      :: p8_5 ! a65 ->

        state = 87;
      fi
    }
  :: state == 86 ->
    atomic {
      if
      :: p8_5 ! a65 ->

        state = 83;
      fi
    }
  :: state == 87 ->
    atomic {
      if
      :: p10_8 ? a27 ->
        act ! a27;
        state = 80;
      :: p10_8 ? a16 ->
        act ! a16;
        state = 81;
      fi
    }
  :: state == 80 ->
    atomic {
      if
      :: p8_3 ! a42 ->

        state = 77;
      fi
    }
  :: state == 77 ->
    atomic {
      if
      :: p8_3 ! a62 ->

        state = 84;
      fi
    }
  :: state == 84 ->
    atomic {
      if
      :: p8_5 ! a63 ->

        state = 78;
      fi
    }
  :: state == 78 ->
    atomic {
      if
      :: p8_3 ! a64 ->

        state = 88;
      fi
    }
  :: state == 88 ->
    atomic {
      if
      :: p8_5 ! a65 ->

        state = 76;
      fi
    }
  :: state == 76 ->
    atomic {
      if
      :: p10_8 ? a16 ->
        act ! a16;
        state = 80;
      :: p10_8 ? a27 ->
        act ! a27;
        state = 80;
      :: p10_8 ? a14 ->
        act ! a14;
        state = 80;
      :: p8_3 ! a64 ->

        state = 79;
      fi
    }
  od
}

/* Process 9 */
active proctype Proc9()
{
  int state = 113;
  do
  :: state == 113 ->
    atomic {
      if
      :: p9 ? nop ->

        state = 96;
      fi
    }
  :: state == 96 ->
    atomic {
      if
      :: p9_7 ! a38 ->

        state = 103;
      :: p9_7 ! a39 ->

        state = 97;
      fi
    }
  :: state == 103 ->
    atomic {
      if
      :: p9_2 ! a34 ->

        state = 107;
      fi
    }
  :: state == 97 ->
    atomic {
      if
      :: p9_2 ! a34 ->

        state = 110;
      fi
    }
  :: state == 107 ->
    atomic {
      if
      :: p9_1 ! a58 ->

        state = 98;
      :: p9_2 ! a34 ->

        state = 109;
      fi
    }
  :: state == 110 ->
    atomic {
      if
      :: p9_1 ! a58 ->

        state = 112;
      fi
    }
  :: state == 98 ->
    atomic {
      if
      :: p9_1 ! a59 ->

        state = 104;
      fi
    }
  :: state == 109 ->
    atomic {
      if
      :: p9_1 ! a58 ->

        state = 109;
      :: p9_2 ! a60 ->

        state = 109;
      :: p9_7 ! a39 ->

        state = 109;
      :: p9_1 ! a59 ->

        state = 109;
      fi
    }
  :: state == 112 ->
    atomic {
      if
      :: p9_1 ! a59 ->

        state = 108;
      fi
    }
  :: state == 104 ->
    atomic {
      if
      :: p9_2 ! a60 ->

        state = 100;
      fi
    }
  :: state == 108 ->
    atomic {
      if
      :: p9_2 ! a60 ->

        state = 102;
      fi
    }
  :: state == 100 ->
    atomic {
      if
      :: p9_7 ! a39 ->

        state = 95;
      :: p9_7 ! a38 ->

        state = 97;
      fi
    }
  :: state == 102 ->
    atomic {
      if
      :: p9_1 ! a59 ->

        state = 101;
      :: p9_7 ! a38 ->

        state = 97;
      fi
    }
  :: state == 95 ->
    atomic {
      if
      :: p9_2 ! a34 ->

        state = 105;
      fi
    }
  :: state == 101 ->
    atomic {
      if
      :: p9_2 ! a34 ->

        state = 101;
      :: p9_2 ! a60 ->

        state = 101;
      fi
    }
  :: state == 105 ->
    atomic {
      if
      :: p9_1 ! a58 ->

        state = 111;
      fi
    }
  :: state == 111 ->
    atomic {
      if
      :: p9_1 ! a59 ->

        state = 99;
      fi
    }
  :: state == 99 ->
    atomic {
      if
      :: p9_2 ! a60 ->

        state = 106;
      fi
    }
  :: state == 106 ->
    atomic {
      if
      :: p9_7 ! a38 ->

        state = 103;
      fi
    }
  od
}

/* Process 10 */
active proctype Proc10()
{
  int state = 143;
  do
  :: state == 143 ->
    atomic {
      if
      :: p10 ? nop ->

        state = 119;
      fi
    }
  :: state == 119 ->
    atomic {
      if
      :: p10 ? a24 ->
        act ! a24;
        state = 122;
      :: p10 ? a31 ->
        act ! a31;
        state = 118;
      :: p10 ? a3 ->
        act ! a3;
        state = 121;
      :: p10 ? a49 ->
        act ! a49;
        state = 116;
      :: p10 ? a13 ->
        act ! a13;
        state = 117;
      fi
    }
  :: state == 122 ->
    atomic {
      if
      :: p10 ? a22 ->
        act ! a22;
        state = 129;
      :: p10 ? a23 ->
        act ! a23;
        state = 119;
      fi
    }
  :: state == 118 ->
    atomic {
      if
      :: p10 ? a26 ->
        act ! a26;
        state = 121;
      fi
    }
  :: state == 121 ->
    atomic {
      if
      :: p10 ? a43 ->
        act ! a43;
        state = 123;
      :: p10 ? a4 ->
        act ! a4;
        state = 117;
      :: p10 ? a25 ->
        act ! a25;
        state = 128;
      fi
    }
  :: state == 116 ->
    atomic {
      if
      :: p10_4 ! a45 ->

        state = 115;
      :: p10 ? a52 ->
        act ! a52;
        state = 114;
      fi
    }
  :: state == 117 ->
    atomic {
      if
      :: p10 ? a56 ->
        act ! a56;
        state = 122;
      :: p10 ? a12 ->
        act ! a12;
        state = 120;
      :: p10_8 ! a27 ->

        state = 119;
      fi
    }
  :: state == 129 ->
    atomic {
      if
      :: p10 ? a57 ->
        act ! a57;
        state = 131;
      fi
    }
  :: state == 123 ->
    atomic {
      if
      :: p10 ? a30 ->
        act ! a30;
        state = 132;
      fi
    }
  :: state == 128 ->
    atomic {
      if
      :: p10_8 ! a16 ->

        state = 130;
      :: p10_7 ! a28 ->

        state = 125;
      fi
    }
  :: state == 115 ->
    atomic {
      if
      :: p10 ? a57 ->
        act ! a57;
        state = 115;
      :: p10_4 ! a46 ->

        state = 115;
      :: p10 ? a32 ->
        act ! a32;
        state = 115;
      :: p10_8 ! a27 ->

        state = 115;
      :: p10 ? a22 ->
        act ! a22;
        state = 115;
      :: p10 ? a56 ->
        act ! a56;
        state = 115;
      :: p10 ? a25 ->
        act ! a25;
        state = 115;
      :: p10_4 ! a45 ->

        state = 115;
      :: p10 ? a55 ->
        act ! a55;
        state = 115;
      :: p10_7 ! a6 ->

        state = 115;
      :: p10_4 ! a8 ->

        state = 115;
      :: p10 ? a2 ->
        act ! a2;
        state = 115;
      :: p10 ? a18 ->
        act ! a18;
        state = 115;
      :: p10 ? a1 ->
        act ! a1;
        state = 115;
      :: p10 ? a5 ->
        act ! a5;
        state = 115;
      :: p10_8 ! a14 ->

        state = 115;
      :: p10 ? a29 ->
        act ! a29;
        state = 115;
      :: p10 ? a12 ->
        act ! a12;
        state = 115;
      :: p10_8 ! a16 ->

        state = 115;
      :: p10 ? a4 ->
        act ! a4;
        state = 115;
      :: p10 ? a48 ->
        act ! a48;
        state = 115;
      :: p10 ? a30 ->
        act ! a30;
        state = 115;
      fi
    }
  :: state == 114 ->
    atomic {
      if
      :: p10 ? a51 ->
        act ! a51;
        state = 132;
      fi
    }
  :: state == 120 ->
    atomic {
      if
      :: p10 ? a11 ->
        act ! a11;
        state = 119;
      :: p10 ? a10 ->
        act ! a10;
        state = 126;
      fi
    }
  :: state == 131 ->
    atomic {
      if
      :: p10 ? a55 ->
        act ! a55;
        state = 117;
      fi
    }
  :: state == 132 ->
    atomic {
      if
      :: p10 ? a29 ->
        act ! a29;
        state = 121;
      :: p10 ? a44 ->
        act ! a44;
        state = 138;
      :: p10_4 ! a46 ->

        state = 137;
      :: p10_4 ! a8 ->

        state = 135;
      fi
    }
  :: state == 130 ->
    atomic {
      if
      :: p10 ? a17 ->
        act ! a17;
        state = 130;
      :: p10 ? a29 ->
        act ! a29;
        state = 130;
      :: p10 ? a15 ->
        act ! a15;
        state = 130;
      :: p10 ? a12 ->
        act ! a12;
        state = 130;
      :: p10 ? a26 ->
        act ! a26;
        state = 130;
      :: p10 ? a50 ->
        act ! a50;
        state = 130;
      :: p10 ? a49 ->
        act ! a49;
        state = 136;
      :: p10_7 ! a28 ->

        state = 130;
      :: p10 ? a24 ->
        act ! a24;
        state = 130;
      :: p10_8 ! a27 ->

        state = 130;
      :: p10 ? a23 ->
        act ! a23;
        state = 130;
      :: p10_4 ! a46 ->

        state = 130;
      :: p10 ? a52 ->
        act ! a52;
        state = 130;
      :: p10 ? a43 ->
        act ! a43;
        state = 130;
      :: p10 ? a4 ->
        act ! a4;
        state = 130;
      :: p10 ? a3 ->
        act ! a3;
        state = 130;
      :: p10_7 ! a6 ->

        state = 130;
      :: p10_4 ! a8 ->

        state = 130;
      :: p10_7 ! a7 ->

        state = 130;
      :: p10 ? a2 ->
        act ! a2;
        state = 130;
      :: p10 ? a18 ->
        act ! a18;
        state = 130;
      fi
    }
  :: state == 125 ->
    atomic {
      if
      :: p10 ? a32 ->
        act ! a32;
        state = 119;
      :: p10_7 ! a6 ->

        state = 141;
      fi
    }
  :: state == 126 ->
    atomic {
      if
      :: p10 ? a47 ->
        act ! a47;
        state = 132;
      :: p10 ? a50 ->
        act ! a50;
        state = 119;
      :: p10 ? a1 ->
        act ! a1;
        state = 124;
      fi
    }
  :: state == 138 ->
    atomic {
      if
      :: p10 ? a48 ->
        act ! a48;
        state = 126;
      fi
    }
  :: state == 137 ->
    atomic {
      if
      :: p10_4 ! a45 ->

        state = 126;
      fi
    }
  :: state == 135 ->
    atomic {
      if
      :: p10 ? a5 ->
        act ! a5;
        state = 125;
      fi
    }
  :: state == 136 ->
    atomic {
      if
      :: p10 ? a31 ->
        act ! a31;
        state = 136;
      :: p10_7 ! a28 ->

        state = 136;
      :: p10 ? a22 ->
        act ! a22;
        state = 136;
      :: p10 ? a25 ->
        act ! a25;
        state = 136;
      :: p10 ? a24 ->
        act ! a24;
        state = 140;
      :: p10 ? a52 ->
        act ! a52;
        state = 136;
      :: p10 ? a51 ->
        act ! a51;
        state = 130;
      :: p10 ? a44 ->
        act ! a44;
        state = 136;
      :: p10 ? a43 ->
        act ! a43;
        state = 136;
      :: p10 ? a48 ->
        act ! a48;
        state = 136;
      :: p10_4 ! a8 ->

        state = 136;
      :: p10 ? a1 ->
        act ! a1;
        state = 136;
      :: p10 ? a47 ->
        act ! a47;
        state = 136;
      :: p10 ? a2 ->
        act ! a2;
        state = 136;
      :: p10_7 ! a6 ->

        state = 136;
      :: p10_8 ! a16 ->

        state = 136;
      :: p10_8 ! a14 ->

        state = 136;
      :: p10 ? a29 ->
        act ! a29;
        state = 136;
      :: p10 ? a12 ->
        act ! a12;
        state = 136;
      fi
    }
  :: state == 141 ->
    atomic {
      if
      :: p10_7 ! a7 ->

        state = 132;
      fi
    }
  :: state == 124 ->
    atomic {
      if
      :: p10 ? a2 ->
        act ! a2;
        state = 139;
      fi
    }
  :: state == 140 ->
    atomic {
      if
      :: p10 ? a24 ->
        act ! a24;
        state = 140;
      :: p10_7 ! a7 ->

        state = 140;
      :: p10 ? a1 ->
        act ! a1;
        state = 140;
      :: p10_8 ! a16 ->

        state = 140;
      :: p10 ? a30 ->
        act ! a30;
        state = 140;
      :: p10 ? a32 ->
        act ! a32;
        state = 140;
      :: p10_8 ! a14 ->

        state = 140;
      :: p10 ? a12 ->
        act ! a12;
        state = 140;
      :: p10 ? a13 ->
        act ! a13;
        state = 140;
      :: p10_7 ! a28 ->

        state = 140;
      :: p10 ? a22 ->
        act ! a22;
        state = 140;
      :: p10 ? a43 ->
        act ! a43;
        state = 140;
      :: p10_4 ! a8 ->

        state = 140;
      :: p10 ? a9 ->
        act ! a9;
        state = 140;
      :: p10 ? a31 ->
        act ! a31;
        state = 140;
      fi
    }
  :: state == 139 ->
    atomic {
      if
      :: p10 ? a18 ->
        act ! a18;
        state = 142;
      fi
    }
  :: state == 142 ->
    atomic {
      if
      :: p10 ? a17 ->
        act ! a17;
        state = 127;
      fi
    }
  :: state == 127 ->
    atomic {
      if
      :: p10_8 ! a14 ->

        state = 134;
      :: p10 ? a9 ->
        act ! a9;
        state = 120;
      fi
    }
  :: state == 134 ->
    atomic {
      if
      :: p10_8 ! a16 ->

        state = 133;
      fi
    }
  :: state == 133 ->
    atomic {
      if
      :: p10 ? a15 ->
        act ! a15;
        state = 127;
      fi
    }
  od
}

/* Process 11 */
active proctype Proc11()
{
  int state = 148;
  do
  :: state == 148 ->
    atomic {
      if
      :: p11 ? nop ->

        state = 147;
      fi
    }
  :: state == 147 ->
    atomic {
      if
      :: p11_4 ! a40 ->

        state = 145;
      :: p11_4 ! a37 ->

        state = 146;
      fi
    }
  :: state == 145 ->
    atomic {
      if
      :: p11_4 ! a40 ->

        state = 145;
      fi
    }
  :: state == 146 ->
    atomic {
      if
      :: p11_4 ! a40 ->

        state = 145;
      :: p11_4 ! a36 ->

        state = 144;
      fi
    }
  :: state == 144 ->
    atomic {
      if
      :: p11_4 ! a40 ->

        state = 147;
      fi
    }
  od
}

#define p_a10	 (lastAction == a10)
#define p_a4	 (lastAction == a4)
#define p_a50	 (lastAction == a50)
#define p_a47	 (lastAction == a47)
#define p_a2	 (lastAction == a2)
#define p_a26	 (lastAction == a26)
#define p_a3	 (lastAction == a3)
#define p_a51	 (lastAction == a51)
#define p_a44	 (lastAction == a44)
#define p_a13	 (lastAction == a13)
#define p_a12	 (lastAction == a12)
#define p_a52	 (lastAction == a52)
#define p_a15	 (lastAction == a15)
#define p_a30	 (lastAction == a30)
#define p_a18	 (lastAction == a18)
#define p_a9	 (lastAction == a9)
#define p_a31	 (lastAction == a31)
#define p_a1	 (lastAction == a1)
#define p_a17	 (lastAction == a17)
#define p_a57	 (lastAction == a57)
#define p_a32	 (lastAction == a32)
#define p_a48	 (lastAction == a48)
#define p_a55	 (lastAction == a55)
#define p_a25	 (lastAction == a25)
#define p_a29	 (lastAction == a29)
#define p_a24	 (lastAction == a24)
#define p_a7	 (lastAction == a7)
#define p_a41	 (lastAction == a41)
#define p_a39	 (lastAction == a39)
#define p_a33	 (lastAction == a33)
#define p_a61	 (lastAction == a61)
#define p_a22	 (lastAction == a22)
#define p_a21	 (lastAction == a21)
#define p_a11	 (lastAction == a11)
#define p_a63	 (lastAction == a63)
#define p_a8	 (lastAction == a8)
#define p_a16	 (lastAction == a16)
#define p_a40	 (lastAction == a40)
#define p_a35	 (lastAction == a35)
#define p_a28	 (lastAction == a28)
#define p_a42	 (lastAction == a42)
#define p_a6	 (lastAction == a6)
#define p_a65	 (lastAction == a65)
#define p_a64	 (lastAction == a64)
#define p_a36	 (lastAction == a36)
#define p_a60	 (lastAction == a60)
#define p_a14	 (lastAction == a14)
#define p_a27	 (lastAction == a27)
#define p_a34	 (lastAction == a34)
#define p_a62	 (lastAction == a62)
#define p_a46	 (lastAction == a46)
#define p_a59	 (lastAction == a59)
#define p_a5	 (lastAction == a5)
#define p_a38	 (lastAction == a38)
#define p_a58	 (lastAction == a58)
#define p_a19	 (lastAction == a19)
#define p_a20	 (lastAction == a20)
#define p_a37	 (lastAction == a37)
#define p_a23	 (lastAction == a23)
#define p_a54	 (lastAction == a54)
#define p_a45	 (lastAction == a45)
#define p_a56	 (lastAction == a56)
#define p_a49	 (lastAction == a49)
#define p_a53	 (lastAction == a53)
#define p_a43	 (lastAction == a43)


ltl p1	{ p_a16 V (!p_a15 || p_a16 || <>p_a26) }
ltl p2	{ (p_a9 || p_a45) V (p_a9 || !p_a23 || p_a45 || []!p_a13) }
ltl p3	{ (p_a31 || p_a49) V (!p_a26 || p_a31 || p_a49) }
ltl p4	{ p_a2 V (p_a2 || !p_a15) }
ltl p5	{ (p_a5 || p_a7) V (p_a5 || p_a7 || !p_a47 || []!p_a56) }
ltl p6	{ [](!p_a5 || (p_a46 V (!p_a45 || p_a46))) }
ltl p7	{ p_a55 V (!p_a11 || p_a55 || <>p_a5) }
ltl p8	{ (p_a2 || p_a48) V (p_a2 || p_a48 || !(p_a14 || p_a18)) }
ltl p9	{ (p_a1 || p_a27) V (p_a1 || !p_a15 || p_a27 || (!p_a55 U p_a31)) }
ltl p10	{ (p_a10 || p_a52) V (p_a10 || !p_a51 || p_a52) }
ltl p11	{ p_a2 V (p_a2 || !p_a16 || (!p_a6 U p_a7)) }
ltl p12	{ []((!p_a6 || <>p_a7) && (!p_a47 || []!p_a9)) }
ltl p13	{ p_a7 V (p_a7 || !p_a9 || <>p_a4) }
ltl p14	{ (p_a5 || p_a25) V (p_a5 || p_a25 || !p_a28) }
ltl p15	{ p_a6 V (p_a6 || !p_a7 || []!p_a15) }
ltl p16	{ p_a55 V (p_a55 || !(p_a8 || p_a51)) }
ltl p17	{ (p_a13 || p_a49) V (p_a13 || !p_a17 || p_a49 || (p_a9 V (p_a9 || !p_a44))) }
ltl p18	{ (p_a1 || p_a3) V (p_a1 || p_a3 || !p_a17) }
ltl p19	{ <>(p_a55 V (!p_a30 || p_a55)) }
ltl p20	{ p_a57 V (p_a57 || !(p_a7 || p_a24)) }
